library tendo;

import 'dart:convert';
import 'package:http/http.dart' as http;
import 'package:tendo/CreateAccountRequest.dart';
import 'package:tendo/CreateAccountResponse.dart';
import 'package:tendo/GetAccountRequest.dart';
import 'package:tendo/GetAccountResponse.dart';
import 'package:tendo/GetProductRequest.dart';
import 'package:tendo/CreateOrderRequest.dart';
import 'package:tendo/CreateOrderResponse.dart';
import 'package:tendo/GetOrderRequest.dart';
import 'package:tendo/GetOrderResponse.dart';
import 'package:tendo/ShareResponse.dart';
import 'package:tendo/ShareRequest.dart';
import 'package:tendo/WishlistRequest.dart';
import 'package:tendo/WishlistResponse.dart';
import 'package:tendo/SharelistRequest.dart';
import 'package:tendo/SharelistResponse.dart';
import 'package:tendo/GetWishistRequest.dart';
import 'package:tendo/GetWishistResponse.dart';


class Tendo {

  var baseUrl="http://tendo-api.westeurope.azurecontainer.io";

  Future<CreateAccountResponse> createAccount (CreateAccountRequest accountRequest) async {
    var json = jsonEncode(accountRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/createAccount",
        headers: {"Content-Type": "application/json"},
        body: json);
    return CreateAccountResponse.fromJson(jsonDecode(response.body));
  }

  Future<GetAccountResponse> getAccount(GetAccountRequest accountRequest) async {
    var json = jsonEncode(accountRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/getAccount",
        headers: {"Content-Type": "application/json"},
        body: json);
    return GetAccountResponse.fromJson(jsonDecode(response.body));
  }

  Future<GetAccountResponse> getProduct(GetProductRequest productRequest) async{
    var json = jsonEncode(productRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/getProduct",
        headers: {"Content-Type": "application/json"},
        body: json);
    return GetAccountResponse.fromJson(jsonDecode(response.body));

  }

  Future<CreateOrderResponse> createOrder(CreateOrderRequest orderRequest) async{
    var json = jsonEncode(orderRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/createOrder",
        headers: {"Content-Type": "application/json"},
        body: json);
    return CreateOrderResponse.fromJson(jsonDecode(response.body));
  }

  Future<GetOrderResponse> getOrder (GetOrderRequest orderRequest) async{

    var json = jsonEncode(orderRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/getOrder",
        headers: {"Content-Type": "application/json"},
        body: json);
    return GetOrderResponse.fromJson(jsonDecode(response.body));

  }

  Future<ShareResponse> share (ShareRequest shareRequest) async{
    var json = jsonEncode(shareRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/share",
        headers: {"Content-Type": "application/json"},
        body: json);
    return ShareResponse.fromJson(jsonDecode(response.body));
  }

  Future<WishlistResponse> addToWishlist(WishlistRequest wishlistRequest) async{
    var json = jsonEncode(wishlistRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/addToWishList",
        headers: {"Content-Type": "application/json"},
        body: json);
    return WishlistResponse.fromJson(jsonDecode(response.body));
  }

  Future<GetWishistResponse> getWishlist(GetWishistRequest wishistRequest) async{
    var json = jsonEncode(wishistRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/getWishList",
        headers: {"Content-Type": "application/json"},
        body: json);
    return GetWishistResponse.fromJson(jsonDecode(response.body));
  }

  Future<SharelistResponse> getShareList(SharelistRequest sharelistRequest) async{

    var json = jsonEncode(sharelistRequest.toJson());
    final http.Response response = await http.post( baseUrl+"/shareList",
        headers: {"Content-Type": "application/json"},
        body: json);
    return SharelistResponse.fromJson(jsonDecode(response.body));

  }


}
